C
C   This is a simple example MAIN routine to (hopefully) show how to use
C  the FTXMS routines.
C
C   Put the contents of FTXMS.INC here.
C
C   Dimension four different XMS arrays, one each for the four different
C  supported data types.  Don't process arrays past the point at which
C  the last call to DIMXMS detected a problem accessing XMS.
C
C   Set some default values in case they don't get set below.
C
      EC2=1
      EC3=1
      EC4=1
      EC5=1
      EC6=1
      EC7=1
      CALL DIMXMS('A1        ',100000,'INTGR1',ERCODE)
      EC1=ERCODE
      IF(EC1.NE.0)GO TO 1
      CALL DIMXMS('A2        ',100000,'INTGR4',ERCODE)
      EC2=ERCODE
      IF(EC2.NE.0)GO TO 2
      CALL DIMXMS('A3        ',100000,'REAL*4',ERCODE)
      EC3=ERCODE
      IF(EC3.NE.0)GO TO 3
      CALL DIMXMS('A4        ',100000,'REAL*8',ERCODE)
      EC4=ERCODE
      IF(EC4.NE.0)GO TO 7
      CALL DIMXMS('A5        ',100000,'SCMPLX',ERCODE)
      EC5=ERCODE
      IF(EC5.NE.0)GO TO 8
      CALL DIMXMS('A6        ',100000,'DCMPLX',ERCODE)
      EC6=ERCODE
      IF(EC6.NE.0)GO TO 9
      CALL DIMXMS('A7        ',100000,'INTGR2',ERCODE)
      EC7=ERCODE
      IF(EC7.EQ.0)GO TO 4
      WRITE(6,*)'Couldn''t handle more than six 100000-element XMS array
     .s.'
      GO TO 4
    9 CONTINUE
      WRITE(6,*)'Couldn''t handle more than five 100000-element XMS arra
     .ys.'
      GO TO 4
    8 CONTINUE
      WRITE(6,*)'Couldn''t handle more than four 100000-element XMS arra
     .ys.'
      GO TO 4
    7 CONTINUE
      WRITE(6,*)'Couldn''t handle more than three 100000-element XMS arr
     .ays.'
      GO TO 4
    3 CONTINUE
      WRITE(6,*)'Couldn''t handle more then two 100000-element XMS array
     *s.'
      GO TO 4
    2 CONTINUE
      WRITE(6,*)'Can''t handle more than one 100000-element XMS array.'
      GO TO 4
    1 CONTINUE
      WRITE(6,*)' '
      WRITE(6,*)'Do you have XMS?'
      WRITE(6,*)' '
      STOP
    4 CONTINUE
      WRITE(6,*)' '
      WRITE(6,*)'  Patience.  If your computer isn''t rebooting and you
     .don''t see a '
      WRITE(6,*)'question about your having XMS, FTXMS appears to be wor
     .king.'
      WRITE(6,*)' '
C
C   Put miscellaneous data in XMS arrays.
C
      DO 5 I=1,100000
      V1=INT1(ALOG10(FLOAT(I))/ALOG10(2.)+.001)
C
C   Put data in INTEGER*1 array in reverse order for more robust test of
C  PUTNT1.
C
      CALL PUTNT1('A1        ',100001-I,V1)
      IF(EC2.EQ.0)CALL PUTINT('A2        ',I,I)
      IF(EC3.EQ.0)CALL PUTSNG('A3        ',I,SQRT(FLOAT(I)))
      X=DFLOAT(I)
      X=DSQRT(X)
      IF(EC4.EQ.0)CALL PUTDBL('A4        ',I,X)
      IF(EC5.EQ.0)CALL PUTCMP('A5        ',I,CSQRT(-FLOAT(I)))
      Z2=DCMPLX(DFLOAT(I),DFLOAT(I))
      IF(EC6.EQ.0)CALL PUTC16('A6        ',I,CDSQRT(Z2))
C
C   Can't have 2-byte integers greater than 32767.
C
      V=32767
      IF(I.LT.32768)V=INT2(I)
      IF(EC7.EQ.0)CALL PUTNT2('A7        ',I,V)
    5 CONTINUE
C
C   Retrieve XMS data and print out screenful.
C
      DO 6 I=1,100000,25000
      V1=0
      IF(EC1.EQ.0)V1=GETNT1('A1        ',I)
      N=0
      IF(EC2.EQ.0)N=GETINT('A2        ',I)
      Y=0.
      IF(EC3.EQ.0)Y=GETSNG('A3        ',I)
      X=0.D0
      IF(EC4.EQ.0)X=GETDBL('A4        ',I)
      Z1=(0.,0.)
      IF(EC5.EQ.0)Z1=GETCMP('A5        ',I)
      Z2=(0.D0,0.D0)
      IF(EC6.EQ.0)Z2=GETC16('A6        ',I)
      V=0
      IF(EC7.EQ.0)V=GETNT2('A7        ',I)
      WRITE(6,*)V1,N,Y,X,V
      WRITE(6,*)Z1,Z2
    6 CONTINUE
C
C   Verify that function GETADD works.
C
      ADD1=GETADD('A1        ',N1)
      ADD2=GETADD('A2        ',N2)
      ADD3=GETADD('A3        ',N3)
      ADD4=GETADD('A4        ',N4)
      ADD5=GETADD('A5        ',N5)
      ADD6=GETADD('A6        ',N6)
      ADD7=GETADD('A7        ',N7)
      WRITE(6,*)' '
      WRITE(6,*)'Array sizes and addresses from GETADD:'
      WRITE(6,*)'Names = ','A1        ','A2        ','A3        ','A4
     .     ','A5        ','A6        ','A7'
      WRITE(6,*)'Elements = ',N1,N2,N3,N4,N5,N6,N7
      WRITE(6,*)'Addresses = ',ADD1,ADD2,ADD3,ADD4,ADD5,ADD6,ADD7
      STOP
      END
